#!/bin/bash

usage() {
  cat << EOF

  Usage: $0 <test id> <step id> <test path> <address> <mock json> <method: POST|PUT|GET|DELETE> <uri>

EOF
  exit 1
}

[ -z "$7" ] && usage

control_post_request=$(mktemp)
cat << EOF > ${control_post_request}
{
  "control": {
    "flowId": "$1",
    "flowStepId": "$2",
    "flowPath":"$3"
  },
  "action": {
    "id": "serve_json",
    "arguments": {
      "json": "$5",
      "method": "$6",
      "uri": "$7"
    }
  }
}
EOF

CONTROL_URI=http://$4/aots-control/v1/ctrl/action/annotate
CURL="curl -s --http2-prior-knowledge"
${CURL} -d@${control_post_request} -H "Content-Type: application/json" -X $6 ${CONTROL_URI}/serve_json >/dev/null
rm ${control_post_request}
