#!/bin/bash
dynamicProcedureLibName=libanna_launcher_procedure_default_shared.so
echo
echo "------------------------------------------------"
echo "Dynamic library selection for launcher procedure"
echo "------------------------------------------------"
cd $(dirname $0)
option=$1
rm -f $dynamicProcedureLibName
if [ -z "$option" ]
then
  echo " (you could provide directly the path to the .so file)"
  echo
  echo "Available options:"
  tmpfile=$(mktemp)
  find . -name "libanna_launcher_procedure_*_shared.so" > $tmpfile
  echo
  for line in $(cat $tmpfile); do echo "   $line" ; done
  dflt=$(grep "^./default/" $tmpfile)
  echo
  echo -n "Paste your selection [$dflt]: "
  read option
  [ -z "$option" ] && option=$dflt
  rm $tmpfile 
fi

[ ! -f $option ] && { echo -e "\nInvalid file !\n" ; exit 1 ; }
option_bn=$(basename $option)
ln -sf $option $dynamicProcedureLibName
[ $? -ne 0 ] && { rm -f $dynamicProcedureLibName ; echo -e "\nInvalid file (must be a dynamic procedure library) !\n" ; exit 1 ; }
echo
echo "Library enabled."
echo
echo
echo "IMPORTANT: remember to Re-Start the affected ADML instances:"
echo
echo "   pkill -9 ADML ; ./run.sh"
echo

