#!/bin/bash
#@eramos
echo
echo "This script builds autonomous diameter stack ditionaries for current stack commands"
echo " setups which contain isolated operations but not a full set of avp dependences."
echo "To do this work, uses 'setups.bk/dependence.sh' and 'stackManagement' tool."
echo
echo "Press ENTER to continue, CTRL+C to abort ..."
read dummy

> result.xml
SETUPS_DIR=../../../source/diameter/stack/setups
BASE_PROTOCOL=$SETUPS_DIR/commands_baseProtocol.xml
for i in `ls $SETUPS_DIR/command*xml`
do
   echo
   DICTIONARY_NAME=`basename $i`
   if test "$i" = "$BASE_PROTOCOL"; then continue; fi
   echo "Processing '$DICTIONARY_NAME' ..."
   $SETUPS_DIR/dependence.sh $i >/dev/null
   LIST=`cat ${i}.dep`
   rm ${i}.dep
   /opt/bin/anna/example_diameter_stackManagement $LIST $BASE_PROTOCOL $i >/dev/null
   mv result.xml Autonomous_${DICTIONARY_NAME}
   echo "Generated 'Autonomous_${DICTIONARY_NAME}'"
done
echo

