// ANNA - Anna is Not Nothingness Anymore                                                         //
//                                                                                                //
// (c) Copyright 2005-2015 Eduardo Ramos Testillano & Francisco Ruiz Rayo                         //
//                                                                                                //
// See project site at http://redmine.teslayout.com/projects/anna-suite                           //
// See accompanying file LICENSE or copy at http://www.teslayout.com/projects/public/anna.LICENSE //


#ifndef anna_core_mt_NRMutex_hpp
#define anna_core_mt_NRMutex_hpp

#include <anna/core/mt/Mutex.hpp>

namespace anna {

/**
   Clase para implementar secciones criticas no-reentrantes. El uso general sera el siguiente:

   \code
      mutex.lock ();

      try {
       <implementacion de la seccion critica>

        mutex.unlock ();
      }
      catch (Exception&) {
        mutex.unlock ();
        .... tratamiento de la excepcion ...
      }
   \endcode

   La funcionalidad de esta clase solo estara disponible en aplicaciones multithread.

   @see anna::Guard
   @see anna::Thread
   @see anna::Semaphore
*/
class NRMutex : public Mutex {
public:
  /**
    Constructor.
  */
  NRMutex() : Mutex(Mode::Strict) { ; }
};

} //namespace anna

#endif
