// ANNA - Anna is Not Nothingness Anymore                                                         //
//                                                                                                //
// (c) Copyright 2005-2015 Eduardo Ramos Testillano & Francisco Ruiz Rayo                         //
//                                                                                                //
// See project site at http://redmine.teslayout.com/projects/anna-suite                           //
// See accompanying file LICENSE or copy at http://www.teslayout.com/projects/public/anna.LICENSE //


#ifndef anna_diameter_helpers_dcca_defines_hpp
#define anna_diameter_helpers_dcca_defines_hpp


// Local
#include <anna/diameter/helpers/defines.hpp>

// STL
#include <string>


/** Contextualized definitions (avp id) */
#define anna_diameter_helpers_define_avp(avpname,code)  anna_diameter_helpers_define_avp_in_context(avpname,code,dcca)

/** Contextualized definitions (avp id and values) */
#define anna_diameter_helpers_define_avp_with_values(avpname,code)  anna_diameter_helpers_define_avp_with_values_in_context(avpname,code,dcca)


namespace anna {

namespace diameter {

namespace helpers {

namespace dcca {


/**
* Avps
*/
anna_diameter_helpers_define_avp(CC_Correlation_Id, 411);
anna_diameter_helpers_define_avp(CC_Input_Octets, 412);
anna_diameter_helpers_define_avp(CC_Money, 413);
anna_diameter_helpers_define_avp(CC_Output_Octets, 414);
anna_diameter_helpers_define_avp(CC_Request_Number, 415);
anna_diameter_helpers_define_avp_with_values(CC_Request_Type, 416) {
  enum v_ {
    INITIAL_REQUEST = 1,
    UPDATE_REQUEST = 2,
    TERMINATION_REQUEST = 3,
    EVENT_REQUEST = 4
  };
};

anna_diameter_helpers_define_avp(CC_Service_Specific_Units, 417);
anna_diameter_helpers_define_avp_with_values(CC_Session_Failover, 418) {
  enum v_ {
    FAILOVER_NOT_SUPPORTED = 0,
    FAILOVER_SUPPORTED = 1
  };
};

anna_diameter_helpers_define_avp(CC_Sub_Session_Id, 419);
anna_diameter_helpers_define_avp(CC_Time, 420);
anna_diameter_helpers_define_avp(CC_Total_Octets, 421);
anna_diameter_helpers_define_avp_with_values(Check_Balance_Result, 422) {
  enum v_ {
    ENOUGH_CREDIT = 0,
    NO_CREDIT = 1
  };
};

anna_diameter_helpers_define_avp(Cost_Information, 423);
anna_diameter_helpers_define_avp(Cost_Unit, 424);
anna_diameter_helpers_define_avp(Currency_Code, 425);
anna_diameter_helpers_define_avp_with_values(Credit_Control, 426) {
  enum v_ {
    CREDIT_AUTHORIZATION = 0,
    RE_AUTHORIZATION = 1
  };
};

anna_diameter_helpers_define_avp_with_values(Credit_Control_Failure_Handling, 427) {
  enum v_ {
    TERMINATE = 0,
    CONTINUE = 1,
    RETRY_AND_TERMINATE = 2
  };
};

anna_diameter_helpers_define_avp_with_values(Direct_Debiting_Failure_Handling, 428) {
  enum v_ {
    TERMINATE_OR_BUFFER = 0,
    CONTINUE = 1
  };
};

anna_diameter_helpers_define_avp(Exponent, 429);
anna_diameter_helpers_define_avp(Final_Unit_Indication, 430);
anna_diameter_helpers_define_avp(Granted_Service_Unit, 431);
anna_diameter_helpers_define_avp(Rating_Group, 432);
anna_diameter_helpers_define_avp_with_values(Redirect_Address_Type, 433) {
  enum v_ {
    IPv4_Address = 0,
    IPv6_Address = 1,
    URL = 2,
    SIP_URL = 3
  };
};

anna_diameter_helpers_define_avp(Redirect_Server, 434);
anna_diameter_helpers_define_avp(Redirect_Server_Address, 435);
anna_diameter_helpers_define_avp_with_values(Requested_Action, 436) {
  enum v_ {
    DIRECT_DEBITING = 0,
    REFUND_ACCOUNT = 1,
    CHECK_BALANCE = 2,
    PRICE_ENQUIRY = 3
  };
};

anna_diameter_helpers_define_avp(Requested_Service_Unit, 437);
anna_diameter_helpers_define_avp(Restriction_Filter_Rule, 438);
anna_diameter_helpers_define_avp(Service_Identifier, 439);
anna_diameter_helpers_define_avp(Service_Parameter_Info, 440);
anna_diameter_helpers_define_avp(Service_Parameter_Type, 441);
anna_diameter_helpers_define_avp(Service_Parameter_Value, 442);
anna_diameter_helpers_define_avp(Subscription_Id, 443);
anna_diameter_helpers_define_avp(Subscription_Id_Data, 444);
anna_diameter_helpers_define_avp(Unit_Value, 445);
anna_diameter_helpers_define_avp(Used_Service_Unit, 446);
anna_diameter_helpers_define_avp(Value_Digits, 447);
anna_diameter_helpers_define_avp(Validity_Time, 448);
anna_diameter_helpers_define_avp_with_values(Final_Unit_Action, 449) {
  enum v_ {
    TERMINATE = 0,
    REDIRECT = 1,
    RESTRICT_ACCESS = 2
  };
};

anna_diameter_helpers_define_avp_with_values(Subscription_Id_Type, 450) {
  enum v_ {
    END_USER_E164 = 0,
    END_USER_IMSI = 1,
    END_USER_SIP_URL = 2,
    END_USER_NAI = 3,
    END_USER_PRIVATE = 4
  };
};

anna_diameter_helpers_define_avp(Tariff_Time_Change, 451);
anna_diameter_helpers_define_avp_with_values(Tariff_Change_Usage, 452) {
  enum v_ {
    UNIT_BEFORE_TARIFF_CHANGE = 0,
    UNIT_AFTER_TARIFF_CHANGE = 1,
    UNIT_INDETERMINATE = 2
  };
};

anna_diameter_helpers_define_avp(G_S_U_Pool_Identifier, 453);
anna_diameter_helpers_define_avp_with_values(CC_Unit_Type, 454) {
  enum v_ {
    TIME = 0,
    MONEY = 1,
    TOTAL_OCTETS = 2,
    INPUT_OCTETS = 3,
    OUTPUT_OCTETS = 4,
    SERVICE_SPECIFIC_UNITS = 5
  };
};

anna_diameter_helpers_define_avp_with_values(Multiple_Services_Indicator, 455) {
  enum v_ {
    MULTIPLE_SERVICES_NOT_SUPPORTED = 0,
    MULTIPLE_SERVICES_SUPPORTED = 1
  };
};

anna_diameter_helpers_define_avp(Multiple_Services_Credit_Control, 456);
anna_diameter_helpers_define_avp(G_S_U_Pool_Reference, 457);
anna_diameter_helpers_define_avp(User_Equipment_Info, 458);
anna_diameter_helpers_define_avp_with_values(User_Equipment_Info_Type, 459) {
  enum v_ {
    IMEISV = 0,
    MAC = 1,
    EUI64 = 2,
    MODIFIED_EUI64 = 3
  };
};

anna_diameter_helpers_define_avp(User_Equipment_Info_Value, 460);
anna_diameter_helpers_define_avp(Service_Context_Id, 461);


/**
* Commands
*/
anna_diameter_helpers_define_command_request(Credit_Control_Request, 272);
anna_diameter_helpers_define_command_answer(Credit_Control_Answer, 272);


}
}
}
}


#undef anna_diameter_helpers_define_avp
#undef anna_diameter_helpers_define_avp_with_values

#endif

