// ANNA - Anna is Not Nothingness Anymore                                                         //
//                                                                                                //
// (c) Copyright 2005-2015 Eduardo Ramos Testillano & Francisco Ruiz Rayo                         //
//                                                                                                //
// See project site at http://redmine.teslayout.com/projects/anna-suite                           //
// See accompanying file LICENSE or copy at http://www.teslayout.com/projects/public/anna.LICENSE //


#ifndef anna_diameter_helpers_nas_defines_hpp
#define anna_diameter_helpers_nas_defines_hpp


// Local
#include <anna/diameter/helpers/defines.hpp>

// STL
#include <string>


/** Contextualized definitions (avp id) */
#define anna_diameter_helpers_define_avp(avpname,code)  anna_diameter_helpers_define_avp_in_context(avpname,code,nas)

/** Contextualized definitions (avp id and values) */
#define anna_diameter_helpers_define_avp_with_values(avpname,code)  anna_diameter_helpers_define_avp_with_values_in_context(avpname,code,nas)


namespace anna {

namespace diameter {

namespace helpers {

namespace nas {


/**
* Avps
*/
/*
anna_diameter_helpers_define_avp(Host_IP_Address, 257);
anna_diameter_helpers_define_avp_with_values(Redirect_Host_Usage, 261) {
   enum v_ {
      DONT_CACHE = 0,
      ALL_SESSION = 1,
      ALL_REALM = 2,
      REALM_AND_APPLICATION = 3,
      ALL_APPLICATION = 4,
      ALL_HOST = 5,
      ALL_USER = 6
   };
};
<AA-Request> ::= < Diameter Header: 265, REQ, PXY >
             < Session-Id >
             { Auth-Application-Id }
             { Origin-Host }
             { Origin-Realm }
             { Destination-Realm }
             [ Destination-Host ]
             [ AF-Application-Identifier ]
            *[ Media-Component-Description ]
             [ Service-Info-Status ]
             [ AF-Charging-Identifier ]
             [ SIP-Forking-Indication ]
            *[ Specific-Action ]
            *[ Subscription-Id ]
            *[ Supported-Features ]
             [ Reservation-Priority ]
             [ Framed-IP-Address ]
             [ Framed-IPv6-Prefix ]
                                 [ Called-Station-Id ]
             [ Service-URN ]
             [ Sponsored-Connectivity-Data ]
             [ MPS-Identifier ]
             [ Rx-Request-Type ]
                                 [ Origin-State-Id ]
            *[ Proxy-Info ]
            *[ Route-Record ]
            *[ AVP ]

<AA-Answer> ::=  < Diameter Header: 265, PXY >
             < Session-Id >
             { Auth-Application-Id }
             { Origin-Host }
             { Origin-Realm }
             [ Result-Code ]
             [ Experimental-Result ]
            *[ Access-Network-Charging-Identifier ]
             [ Access-Network-Charging-Address ]
             [ Acceptable-Service-Info ]
             [ IP-CAN-Type ]
             [ RAT-Type ]
            *[ Flows ]
            *[ Supported-Features ]
                  *[ Class ]
             [ Error-Message ]
             [ Error-Reporting-Host ]
            *[ Failed-AVP ]
             [ Origin-State-Id ]
                                *[ Redirect-Host ]
                                 [ Redirect-Host-Usage ]
                                 [ Redirect-Max-Cache-Time ]
            *[ Proxy-Info ]
            *[ AVP ]

*/


/**
* Commands
*/
anna_diameter_helpers_define_command_request(AA_Request, 265);
anna_diameter_helpers_define_command_answer(AA_Answer, 265);


}
}
}
}


#undef anna_diameter_helpers_define_avp
#undef anna_diameter_helpers_define_avp_with_values

#endif
