// ANNA - Anna is Not Nothingness Anymore                                                         //
//                                                                                                //
// (c) Copyright 2005-2015 Eduardo Ramos Testillano & Francisco Ruiz Rayo                         //
//                                                                                                //
// See project site at http://redmine.teslayout.com/projects/anna-suite                           //
// See accompanying file LICENSE or copy at http://www.teslayout.com/projects/public/anna.LICENSE //


#ifndef anna_diameter_helpers_tgpp_defines_hpp
#define anna_diameter_helpers_tgpp_defines_hpp


// Local
#include <anna/diameter/helpers/defines.hpp>

// STL
#include <string>


/** Contextualized definitions (avp id) */
#define anna_diameter_helpers_define_avp(avpname,code)  anna_diameter_helpers_define_avp_in_context(avpname,code,tgpp)

/** Contextualized definitions (avp id and values) */
#define anna_diameter_helpers_define_avp_with_values(avpname,code)  anna_diameter_helpers_define_avp_with_values_in_context(avpname,code,tgpp)


namespace anna {

namespace diameter {

namespace helpers {

namespace tgpp {


/**
* Avps
*/
anna_diameter_helpers_define_avp_with_values(Node_Functionality, 862) {
  enum v_ {
    S_CSCF = 0,
    P_CSCF = 1,
    I_CSCF = 2,
    MRFC = 3,
    MGCF = 4,
    BGCF = 5,
    AS = 6,
    IBCF = 7,
    S_GW = 8,
    P_GW = 9,
    HSGW = 10
  };
};

anna_diameter_helpers_define_avp(User_Session_Id, 830);
anna_diameter_helpers_define_avp(Outgoing_Session_Id, 2320);
anna_diameter_helpers_define_avp_with_values(Session_Priority, 650) {
  enum v_ {
    PRIORITY_0 = 0,
    PRIORITY_1 = 1,
    PRIORITY_2 = 2,
    PRIORITY_3 = 3,
    PRIORITY_4 = 4
  };
};

anna_diameter_helpers_define_avp(Called_Asserted_Identity, 1250);
anna_diameter_helpers_define_avp(Number_Portability_Routing_Information, 2024);
anna_diameter_helpers_define_avp(Carrier_Select_Routing_Information, 2023);
anna_diameter_helpers_define_avp(Alternate_Charged_Party_Address, 1280);
anna_diameter_helpers_define_avp(Requested_Party_Address, 1251);
anna_diameter_helpers_define_avp(Associated_URI, 856);
anna_diameter_helpers_define_avp(Time_Stamps, 833);
anna_diameter_helpers_define_avp(SIP_Request_Timestamp, 834);
anna_diameter_helpers_define_avp(SIP_Response_Timestamp, 835);
anna_diameter_helpers_define_avp(SIP_Request_Timestamp_Fraction, 2301);
anna_diameter_helpers_define_avp(SIP_Response_Timestamp_Fraction, 2302);
anna_diameter_helpers_define_avp(Application_Server_Information, 850);
anna_diameter_helpers_define_avp(Application_Server, 836);
anna_diameter_helpers_define_avp(Application_Provided_Called_Party_Address, 837);
anna_diameter_helpers_define_avp(IMS_Charging_Identifier, 841);
anna_diameter_helpers_define_avp(SDP_Session_Description, 842);
anna_diameter_helpers_define_avp(Served_Party_IP_Address, 848);
anna_diameter_helpers_define_avp(Server_Capabilities, 603);
anna_diameter_helpers_define_avp(Mandatory_Capability, 604);
anna_diameter_helpers_define_avp(Optional_Capability, 605);
anna_diameter_helpers_define_avp(Server_Name, 602);
anna_diameter_helpers_define_avp(Trunk_Group_ID, 851);
anna_diameter_helpers_define_avp(Incoming_Trunk_Group_ID, 852);
anna_diameter_helpers_define_avp(Outgoing_Trunk_Group_ID, 853);
anna_diameter_helpers_define_avp(Bearer_Service, 854);
anna_diameter_helpers_define_avp(Service_Id, 855);
anna_diameter_helpers_define_avp(Service_Specific_Info, 1249);
anna_diameter_helpers_define_avp(Service_Specific_Type, 1257);
anna_diameter_helpers_define_avp(Service_Specific_Data, 863);
anna_diameter_helpers_define_avp(Number_Of_Participants, 885);
anna_diameter_helpers_define_avp(Message_Body, 889);
anna_diameter_helpers_define_avp(Content_Disposition, 828);
anna_diameter_helpers_define_avp_with_values(Originator, 864) {
  enum v_ {
    CALLING_PARTY = 0,
    CALLED_PARTY = 1
  };
};

anna_diameter_helpers_define_avp(Cause_Code, 861);
anna_diameter_helpers_define_avp_with_values(Address_Type, 899) {
  enum v_ {
    EMAIL_ADDRESS = 0,
    MSISDN = 1,
    IPV4_ADDRESS = 2,
    IPV6_ADDRESS = 3,
    NUMERIC_SHORTCODE = 4,
    ALPHANUMERIC_SHORTCODE = 5,
    OTHER = 6,
    IMSI = 7
  };
};
anna_diameter_helpers_define_avp(Access_Network_Information, 1263);
anna_diameter_helpers_define_avp(Early_Media_Description, 1272);
anna_diameter_helpers_define_avp(SDP_TimeStamps, 1273);
anna_diameter_helpers_define_avp(SDP_Offer_Timestamp, 1274);
anna_diameter_helpers_define_avp(SDP_Answer_Timestamp, 1275);
anna_diameter_helpers_define_avp(IMS_Communication_Service_Identifier, 1281);
anna_diameter_helpers_define_avp_with_values(Online_Charging_Flag, 2303) {
  enum v_ {
    ECF_ADDRESS_NOT_PROVIDED = 0,
    ECF_ADDRESS_PROVIDED = 1
  };
};

anna_diameter_helpers_define_avp(Real_Time_Tariff_Information, 2305);
anna_diameter_helpers_define_avp(Tariff_Information, 2060);
anna_diameter_helpers_define_avp(Tariff_XML, 2306);
anna_diameter_helpers_define_avp(Current_Tariff, 2056);
anna_diameter_helpers_define_avp(Next_Tariff, 2057);
anna_diameter_helpers_define_avp(Scale_Factor, 2059);
anna_diameter_helpers_define_avp(Rate_Element, 2058);
anna_diameter_helpers_define_avp_with_values(Reason_Code, 2316) {
  enum v_ {
    UNKNOWN = 0,
    USAGE = 1,
    COMMUNICATION_ATTEMPT_CHARGE = 2,
    SETUP_CHARGE = 3,
    ADD_ON_CHARGE = 4
  };
};

anna_diameter_helpers_define_avp(Unit_Cost, 2061);
anna_diameter_helpers_define_avp(Account_Expiration, 2309);
anna_diameter_helpers_define_avp(Application_Server_ID, 2101);
anna_diameter_helpers_define_avp_with_values(Application_Service_Type, 2102) {
  enum v_ {
    SENDING = 100,
    RECEIVING = 101,
    RETRIEVAL = 102,
    INVITING = 103,
    LEAVING = 104,
    JOINING = 105
  };
};

anna_diameter_helpers_define_avp(Application_Session_ID, 2103);
anna_diameter_helpers_define_avp(Delivery_Status, 2104);
anna_diameter_helpers_define_avp(3GPP_Charging_Id, 2);
anna_diameter_helpers_define_avp_with_values(3GPP_PDP_Type, 3) {
  enum v_ {
    IPV4 = 0,
    PPP = 1,
    IPV6 = 2
  };
};

anna_diameter_helpers_define_avp(3GPP_CG_Address, 4);
anna_diameter_helpers_define_avp(3GPP_GPRS_Neg_QoS_Profile, 5);
anna_diameter_helpers_define_avp(3GPP_SGSN_Address, 6);
anna_diameter_helpers_define_avp(3GPP_GGSN_Address, 7);
anna_diameter_helpers_define_avp(3GPP_IMSI_MCC_MNC, 8);
anna_diameter_helpers_define_avp(3GPP_GGSN_MCC_MNC, 9);
anna_diameter_helpers_define_avp(3GPP_NSAPI, 10);
anna_diameter_helpers_define_avp(3GPP_Session_Stop_Indicator, 11);
anna_diameter_helpers_define_avp(3GPP_Selection_Mode, 12);
anna_diameter_helpers_define_avp(3GPP_Charging_Characteristics, 13);
anna_diameter_helpers_define_avp(3GPP_SGSN_IPv6_Address, 15);
anna_diameter_helpers_define_avp(3GPP_GGSN_IPv6_Address, 16);
anna_diameter_helpers_define_avp(3GPP_SGSN_MCC_MNC, 18);
anna_diameter_helpers_define_avp(3GGP_IMEISV, 20);
anna_diameter_helpers_define_avp(3GPP_Rat_Type, 21);
anna_diameter_helpers_define_avp(3GPP_User_Location_Info, 22);
anna_diameter_helpers_define_avp(3GPP_MS_TimeZone, 23);
anna_diameter_helpers_define_avp(3GPP_CAMEL_Charging_Info, 24);
anna_diameter_helpers_define_avp(Access_Network_Charging_Identifier_Value, 503);
anna_diameter_helpers_define_avp(Quota_Consumption_Time, 811);
anna_diameter_helpers_define_avp(Event_Type, 823);
anna_diameter_helpers_define_avp(SIP_Method, 824);
anna_diameter_helpers_define_avp(Event, 825);
anna_diameter_helpers_define_avp(Content_Type, 826);
anna_diameter_helpers_define_avp(Content_Length, 827);
anna_diameter_helpers_define_avp_with_values(Role_Of_Node, 829) {
  enum v_ {
    ORIGINATING_ROLE = 0,
    TERMINATING_ROLE = 1,
    PROXY_ROLE = 2,
    B2BUA_ROLE = 3
  };
};

anna_diameter_helpers_define_avp(Calling_Party_Address, 831);
anna_diameter_helpers_define_avp(Called_Party_Address, 832);
anna_diameter_helpers_define_avp(Inter_Operator_Identifier, 838);
anna_diameter_helpers_define_avp(Originating_IOI, 839);
anna_diameter_helpers_define_avp(Terminating_IOI, 840);
anna_diameter_helpers_define_avp(SDP_Media_Component, 843);
anna_diameter_helpers_define_avp(SDP_Media_Name, 844);
anna_diameter_helpers_define_avp(SDP_Media_Description, 845);
anna_diameter_helpers_define_avp(CG_Address, 846);
anna_diameter_helpers_define_avp(GGSN_Address, 847);
anna_diameter_helpers_define_avp(Authorized_QoS, 849);
anna_diameter_helpers_define_avp(PS_Furnish_Charging_Information, 865);
anna_diameter_helpers_define_avp(PS_Free_Format_Data, 866);
anna_diameter_helpers_define_avp_with_values(PS_Append_Free_Format_Data, 867) {
  enum v_ {
    APPEND = 0,
    OVERWRITE = 1
  };
};

anna_diameter_helpers_define_avp(Time_Quota_Threshold, 868);
anna_diameter_helpers_define_avp(Volume_Quota_Threshold, 869);
anna_diameter_helpers_define_avp_with_values(Trigger_Type, 870) {
  enum v_ {
    CHANGE_IN_SGSN_IP_ADDRESS = 1,
    CHANGE_IN_QOS = 2,
    CHANGE_IN_LOCATION = 3,
    CHANGE_IN_RAT = 4,
    CHANGEINQOS_TRAFFIC_CLASS = 10,
    CHANGEINQOS_RELIABILITY_CLASS = 11,
    CHANGEINQOS_DELAY_CLASS = 12,
    CHANGEINQOS_PEAK_THROUGHPUT = 13,
    CHANGEINQOS_PRECEDENCE_CLASS = 14,
    CHANGEINQOS_MEAN_THROUGHPUT = 15,
    CHANGEINQOS_MAXIMUM_BIT_RATE_FOR_UPLINK = 16,
    CHANGEINQOS_MAXIMUM_BIT_RATE_FOR_DOWNLINK = 17,
    CHANGEINQOS_RESIDUAL_BER = 18,
    CHANGEINQOS_SDU_ERROR_RATIO = 19,
    CHANGEINQOS_TRANSFER_DELAY = 20,
    CHANGEINQOS_TRAFFIC_HANDLING_PRIORITY = 21,
    CHANGEINQOS_GUARANTEED_BIT_RATE_FOR_UPLINK = 22,
    CHANGEINQOS_GUARANTEED_BIT_RATE_FOR_DOWNLINK = 23,
    CHANGEINLOCATION_MCC = 30,
    CHANGEINLOCATION_MNC = 31,
    CHANGEINLOCATION_RAC = 32,
    CHANGEINLOCATION_LAC = 33,
    CHANGEINLOCATION_CellId = 34,
    CHANGE_IN_MEDIA_COMPOSITION = 40,
    CHANGEINPARTICIPANTS_NMB = 50
  };
};

anna_diameter_helpers_define_avp_with_values(Reporting_Reason, 872) {
  enum v_ {
    THRESHOLD = 0,
    QHT = 1,
    FINAL = 2,
    QUOTA_EXHAUSTED = 3,
    VALIDITY_TIME = 4,
    OTHER_QUOTA_TYPE = 5,
    RATING_CONDITION_CHANGE = 6,
    FORCED_REAUTHORISATION = 7,
    POOL_EXHAUSTED = 8
  };
};

anna_diameter_helpers_define_avp(Service_Information, 873);
anna_diameter_helpers_define_avp(PS_Information, 874);
anna_diameter_helpers_define_avp(IMS_Information, 876);
anna_diameter_helpers_define_avp_with_values(Media_Initiator_Flag, 882) {
  enum v_ {
    CALLING_PARTY = 0,
    CALLED_PARTY = 1,
    UNKNOWN = 2
  };
};

anna_diameter_helpers_define_avp(Expires, 888);
anna_diameter_helpers_define_avp(Charging_Rule_Base_Name, 1004);
anna_diameter_helpers_define_avp_with_values(Type_Number, 1204);
anna_diameter_helpers_define_avp(Unit_Quota_Threshold, 1226);
anna_diameter_helpers_define_avp(PDP_Address, 1227);
anna_diameter_helpers_define_avp(SGSN_Address, 1228);
anna_diameter_helpers_define_avp(PDP_Context_Type, 1247);
anna_diameter_helpers_define_avp(Service_Generic_Information, 1256);
anna_diameter_helpers_define_avp(Trigger, 1264);
anna_diameter_helpers_define_avp(Media_Initiator_Party, 1288);
anna_diameter_helpers_define_avp_with_values(Low_Balance_Indication, 2020) {
  enum v_ {
    NOT_APPLICABLE = 0,
    YES = 1
  };
};

anna_diameter_helpers_define_avp(Remaining_Balance, 2021);
anna_diameter_helpers_define_avp(Refund_Information, 2022);
anna_diameter_helpers_define_avp_with_values(SDP_Type, 2036) {
  enum v_ {
    SDP_OFFER = 0,
    SDP_ANSWER = 1
  };
};


/**
* Commands
*/


}
}
}
}


#undef anna_diameter_helpers_define_avp
#undef anna_diameter_helpers_define_avp_with_values

#endif

