// ANNA - Anna is Not Nothingness Anymore                                                         //
//                                                                                                //
// (c) Copyright 2005-2015 Eduardo Ramos Testillano & Francisco Ruiz Rayo                         //
//                                                                                                //
// See project site at http://redmine.teslayout.com/projects/anna-suite                           //
// See accompanying file LICENSE or copy at http://www.teslayout.com/projects/public/anna.LICENSE //


#ifndef anna_io_TextReader_hpp
#define anna_io_TextReader_hpp

#include <anna/io/AbstractReader.hpp>

namespace anna {

namespace io {

/**
   Lector de ficheros de texto.
*/
class TextReader : public AbstractReader {
public:
  /**
     Constructor.
     \param maxLength Longitud mxima de lnea del fichero a tratar.
     \warning Con esta clase solo podemos tratar archivos de texto. Si utilizamos este constructor
     debemos invocar al mtodo open antes de usar cualquier otro mtodo de la clase.
  */
  TextReader(const int maxLength = 512);

  /**
     Constructor.
     \param filename Ruta completa del fichero a leer.
     \param maxLength Longitud mxima de lnea del fichero a tratar.
     \warning Con esta clase solo podemos tratar archivos de texto.
  */
  TextReader(const char* filename, const int maxLength = 512);

  /**
     Constructor.
     \param filename Ruta completa del fichero a leer.
     \param maxLength Longitud mxima de lnea del fichero a tratar.
     \warning Con esta clase solo podemos tratar archivos de texto.
  */
  TextReader(const std::string& filename, const int maxLength = 512);

  /**
     Destructor.
  */
  virtual ~TextReader();

  /**
     Devuelve el contenido de la lnea actual o NULL si se ha llegado al fin del fichero.
     \return El contenido de la lnea actual o NULL si se ha llegado al fin del fichero.
  */
  const char* fetch() throw(anna::RuntimeException);

private:
  char* a_buffer;
  const int a_maxLength;
};

}
}
#endif
