// ANNA - Anna is Not Nothingness Anymore                                                         //
//                                                                                                //
// (c) Copyright 2005-2015 Eduardo Ramos Testillano & Francisco Ruiz Rayo                         //
//                                                                                                //
// See project site at http://redmine.teslayout.com/projects/anna-suite                           //
// See accompanying file LICENSE or copy at http://www.teslayout.com/projects/public/anna.LICENSE //


#ifndef anna_test_Communicator_hpp
#define anna_test_Communicator_hpp

#include <anna/comm/Communicator.hpp>

namespace test {

using namespace anna;

class Communicator : public comm::Communicator {
public:
   Communicator () : comm::Communicator (),
      a_maxMessage (-1), 
      a_messageCounter (0), 
      a_successCounter (0),
      a_initTime (0),
      a_avgDelay ("AvgDelay"),
      a_delay (0)
   {;}
   
   void setDelay (const Millisecond delay) throw () { a_delay = delay; }
   void setMaxMessage (const int maxMessage) throw () { a_maxMessage = maxMessage; }
   
   int getMaxMessage () const throw () { return a_maxMessage; }
   int getMessage () const throw () { return a_messageCounter; }

   bool canContinue (const comm::ClientSocket&) throw (RuntimeException);
   void delay () throw (RuntimeException);   
   
   void terminate () throw ();
private:
   Millisecond a_delay;
   Millisecond a_initTime;
   int a_maxMessage;
   int a_messageCounter;
   int a_successCounter;
   Average <Microsecond> a_avgDelay;
   
   void eventOverQuota (const comm::ClientSocket&) throw ();      

};

}

#endif
