// ANNA - Anna is Not Nothingness Anymore                                                         //
//                                                                                                //
// (c) Copyright 2005-2015 Eduardo Ramos Testillano & Francisco Ruiz Rayo                         //
//                                                                                                //
// See project site at http://redmine.teslayout.com/projects/anna-suite                           //
// See accompanying file LICENSE or copy at http://www.teslayout.com/projects/public/anna.LICENSE //


#include <anna/core/mt/Guard.hpp>

#include <anna/xml/Node.hpp>
#include <anna/xml/Attribute.hpp>

#include <anna/comm/ReceiverFactory.hpp>
#include <anna/comm/Receiver.hpp>

using namespace std;
using namespace anna;

comm::ReceiverFactory::ReceiverFactory(const char* name) :
  a_name(name) {
  WHEN_SINGLETHREAD(
    a_receiver = NULL;
  )
}

//---------------------------------------------------------------------------------------------
// En entornos ST solo habra una unica instancia compartida por todos los comm::ClientSocket
//---------------------------------------------------------------------------------------------
comm::Receiver* comm::ReceiverFactory::create()
throw(RuntimeException) {
  comm::Receiver* result(NULL);
  WHEN_SINGLETHREAD(

  if((result = a_receiver) == NULL) {
  result = a_receiver = do_create();
    result->initialize();
  }
  )
  WHEN_MULTITHREAD(
    Guard guard(*this, "comm::ReceiverFactory::create");
    result = do_create();
    result->initialize();
  )
  return result;
}

void comm::ReceiverFactory::release(comm::Receiver* receiver)
throw() {
  WHEN_MULTITHREAD(

  try {
    Guard guard(*this, "comm::ReceiverFactory::release");
    do_release(receiver);
  } catch(RuntimeException& ex) {
  ex.trace();
  }
  );
}

xml::Node* comm::ReceiverFactory::asXML(xml::Node* parent) const
throw() {
  xml::Node* result = parent->createChild("Receiver");
  result->createAttribute("Name", a_name);
  return result;
}



