// ANNA - Anna is Not Nothingness Anymore                                                         //
//                                                                                                //
// (c) Copyright 2005-2015 Eduardo Ramos Testillano & Francisco Ruiz Rayo                         //
//                                                                                                //
// See project site at http://redmine.teslayout.com/projects/anna-suite                           //
// See accompanying file LICENSE or copy at http://www.teslayout.com/projects/public/anna.LICENSE //


#include <anna/core/functions.hpp>

#include <anna/comm/Resource.hpp>

#include <anna/xml/Node.hpp>
#include <anna/xml/Attribute.hpp>

using namespace std;
using namespace anna;

xml::Node* comm::Resource::asXML(xml::Node* parent) const
throw(RuntimeException) {
  xml::Node* result = parent->createChild("comm.Resource");
  result->createAttribute("Name", getName());
  result->createAttribute("Enabled", functions::asString(isEnabled()));
  result->createAttribute("Available", functions::asString(isAvailable()));
  return result;
}

void comm::Resource::asAttribute(xml::Node* node) const
throw(RuntimeException) {
  node->createAttribute("Name", getName());
  node->createAttribute("Enabled", functions::asString(isEnabled()));
  node->createAttribute("Available", functions::asString(isAvailable()));
}
