#!/bin/bash

#############
# VARIABLES #
#############
BASE_PROTOCOL_XML=commands_baseProtocol.xml

#############
# FUNCTIONS #
#############
_exit () {
  echo
  echo $1
  echo
  exit 1
}

usage () {
  echo
  echo
  echo "Usage: makeAutonomous.sh <incomplete dictionary> <stack management executable>"
  echo
  echo "       For example:"
  echo "          makeAutonomous.sh commands_qosControl.xml ./stack-mgmt"
  echo
  echo "       A new dictionary will be created: autonomous.commands_qosControl.xml"
  _exit
}

#############
# EXECUTION #
#############
[ -z "$2" ] && usage

COMMAND_XML=$1
[ "$COMMAND_XML" = "$BASE_PROTOCOL_XML" ] && _exit "$COMMAND_XML skipped !"

STACK_EXE=`readlink -f $2`
target=autonomous.${COMMAND_XML}
cd `dirname $0`

echo -n "Creating $target ... "
0>.dict_list
./dependence.sh $COMMAND_XML >/dev/null
for i in `cat ${COMMAND_XML}.dep`; do echo -n "$i " >> .dict_list ; done
echo "$BASE_PROTOCOL_XML $COMMAND_XML" >> .dict_list

# Create autonomous dictionary:
$STACK_EXE `cat .dict_list` >/dev/null
mv result.xml $target

# Cleanup:
rm -f *.dep
rm -f example_diameter_stackManagement.trace*
rm .dict_list
echo "Done!"

