// ANNA - Anna is Not Nothingness Anymore                                                         //
//                                                                                                //
// (c) Copyright 2005-2015 Eduardo Ramos Testillano & Francisco Ruiz Rayo                         //
//                                                                                                //
// See project site at http://redmine.teslayout.com/projects/anna-suite                           //
// See accompanying file LICENSE or copy at http://www.teslayout.com/projects/public/anna.LICENSE //


#include <libxml/parser.h>

#include <anna/core/tracing/Logger.hpp>
#include <anna/core/tracing/TraceMethod.hpp>
#include <anna/config/defines.hpp>
#include <anna/core/functions.hpp>

#include <anna/xml/DocumentMemory.hpp>

using namespace std;
using namespace anna;
using namespace anna::xml;

_xmlDoc* DocumentMemory::do_initialize(const char* content)
throw(RuntimeException) {
  LOGMETHOD(TraceMethod tf("anna::xml::DocumentMemory", "do_initialize (char*)", ANNA_FILE_LOCATION));
  setContent(content);
  _xmlDoc* result;
  LOGDEBUG(
    string msg("xml::DocumentMemory::do_initialize | Content (char*): ");
    msg += content;
    Logger::debug(msg, ANNA_FILE_LOCATION);
  );

  if((result = xmlParseMemory(content, anna_strlen(content))) == NULL) {
    string msg("xml::DocumentMemory::do_initialize | Content: ");
    msg += content;
    msg += " | Error parsing";
    throw RuntimeException(msg, ANNA_FILE_LOCATION);
  }

  return result;
}

_xmlDoc* DocumentMemory::do_initialize(const anna::DataBlock& content)
throw(RuntimeException) {
  LOGMETHOD(TraceMethod tf("anna::xml::DocumentMemory", "do_initialize (DataBlock)", ANNA_FILE_LOCATION));
  setContent(content);
  _xmlDoc* result;
  LOGDEBUG(
    string msg("xml::DocumentMemory::do_initialize | Content: ");
    msg += functions::asString(content, 24);
    Logger::debug(msg, ANNA_FILE_LOCATION);
  );

  if((result = xmlParseMemory(content.getData(), content.getSize())) == NULL) {
    string msg("xml::DocumentMemory::do_initialize | Content: ");
    msg += functions::asString(content, 24);
    msg += " | Error parsing";
    throw RuntimeException(msg, ANNA_FILE_LOCATION);
  }

  return result;
}
